﻿var currentDomain
var dhxLayout;
var tabbar

var domainpane
var mailboxList
var mailboxPane
var mailboxes

var leftPane;
var rightPane
var domainlist
var domainProperties
var propertySheet
var propertyTabs
var filterlist
var toolbar

var mailboxToolbar
var toolbar

function initPage() {
    dhtmlx.image_path = '/imgs/';

    dhxLayout = new dhtmlXLayoutObject(document.body, '2U');

    domainPane = dhxLayout.cells('a');
    domainPane.setWidth(550)
    domainPane.setText(tmxlang["_domains"]);
    domainlist = domainPane.attachGrid("domaingrid");
    domainlist.attachEvent("onRowSelect", onDomainSelect)
    if (top.edition==2) // relay edition disables the root.login from being deleted.
        domainlist.attachEvent("onRowCreated", OnDomainRowCreated)

    domainlist.attachEvent("onXLE", onDomainDataLoaded)
    domainlist.enableAutoWidth(true)
    domainlist.load('/v7/axml/domainlist.fts', 'xml');
    // construct rhs
    dhxLayout.cells('b').setText(tmxlang["_options"])
    rightPane = dhxLayout.cells('b').attachLayout("1C").cells('a');
    rightPane.setText(tmxlang["_options"])

    toolbar = dhxLayout.cells("a").attachToolbar()
    toolbar.addButton('btn_add', null, tmxlang["_add_domain"], '/images/add.gif')
    toolbar.addButton('btn_alias', null, tmxlang["_alias"], '/images/icons/domainalias.gif', '/images/icons/domainalias.gif')
    toolbar.addButton('btn_rename', null, tmxlang["_btn_rename"], '/images/recur.gif', '/images/recur.gif')

    toolbar.attachEvent("onclick", ToolbarClicked)
    top.SetEvent("reloadDomains", reloadDomainData);
    toolbar.disableItem('btn_alias')
    toolbar.disableItem('btn_rename')

}

function OnDomainRowCreated(id) {
    var name = domainlist.cells(id, 2).getValue()
    if (name == "root.login")
        domainlist.cells(id, 0).setDisabled(true);

}

function ToolbarClicked(id) {
    if (id == "btn_add") {
        top.OpenDialog(700, 350, tmxlang["_add_domain"], '/v7/wizards/adddomain.fts', reloadDomainData)
    }
    if (id=="btn_alias") {
        // clicked the alias column
        window.top.OpenDialog(700, 350, tmxlang["_alias"], '/v7/wizards/adddomainalias.fts?domain=' + currentDomain, reloadDomainData)
        return;
    }
    if (id == "btn_rename") {
        // clicked the ranme button
        window.top.OpenDialog(700, 350, tmxlang["_btn_rename"], '/v7/wizards/renamedomain.fts?domain=' + currentDomain, reloadDomainData)
        return;
    }

}

function reloadDomainData() {
    domainlist.load('/v7/axml/domainlist.fts', 'xml');
}

function onDomainDataLoaded()
{
    var selectedId = domainlist.getRowId(1);
    domainlist.selectRow(0,true,false,true)
    //onDomainSelect(selectedId);
    domainlist.hdr.rows[2].onclick = function (e) { (e || event).cancelBubble = true; }
    domainlist.sortRows(2)
}

var newName = ""
var newType=""
function FilterName() {
    value = document.getElementById("filterName").value.toString()
    domainlist.filterBy(2, value);
    newName = value;
    CheckAdd();
}

function FilterType() {
    value = document.getElementById("filterType").value.toString()
    domainlist.filterBy(3, value);
    newType = value;
}

function AddItem() {
    top.OpenDialog(700, 350, tmxlang["_add_domain"], "/v7/wizards/adddomain.fts", reloadDomainData);
}

function DeleteItem() {
    var checkIds = domainlist.getCheckedRows(0);
    domainlist.clearAll()
    domainlist.load("/v7/axml/domainlist.fts?remove=" + checkIds);
}

function onDomainSelect(id, col) {
    var allowalias = domainlist.getUserData(id, "allowalias")
    var type = domainlist.getUserData(id, "type")
    if (type!=5 && allowalias==1) {
        toolbar.enableItem('btn_alias')
        toolbar.enableItem('btn_rename')
    }
    else {
        toolbar.disableItem('btn_alias')
        toolbar.disableItem('btn_rename')
    }


    var name = domainlist.getUserData(id, "name")
    currentDomain = id


    dhxLayout.cells('b').showHeader()
    var cellObj = domainlist.cellById(id, 2);
    dhxLayout.cells('b').setText(cellObj.getValue())
    // reset the tabbar
    sz = "110px"
    if (type == 3) {

        propertyTabs = rightPane.attachTabbar()
        propertyTabs.setSkin('dhx_skyblue');
        propertyTabs.setImagePath("/imgs/");
        propertyTabs.setHrefMode("iframe");
        propertyTabs.attachEvent("onSelect", domainTabSelect);
        propertyTabs.addTab("tab_mailboxes", tmxlang["_mailboxes"], sz);
        propertyTabs.addTab("tab_general", tmxlang["_general"], sz);
        propertyTabs.addTab("tab_signature", tmxlang["_signature"], sz);
        propertyTabs.addTab("tab_filters", tmxlang["_filters"], sz);
        propertyTabs.addTab("tab_privilages", tmxlang["_privileges"], sz);
        propertyTabs.addTab("tab_tools", tmxlang["_tools"], sz);
        //propertyTabs.addTab("b4", tmxlang["_tab_ad"], sz);
        //propertyTabs.addTab("b5", tmxlang["_tab_migration"], sz);
        propertyTabs.enableAutoReSize(true);
        propertyTabs.setTabActive("tab_mailboxes")

    }
    if (type == 4) {
        rightPane.attachURL("/v7/webadmin/mailboxes/remote.fts?id=" + currentDomain);
    }
    if (type == 5 || type==17) {
        // ignore it
        rightPane.attachURL("/v7/utility/noedit.fts");
    }
}

function domainTabSelect(id) {

    if (id == "tab_mailboxes") 
    {
        var l = propertyTabs.cells(id)
        l.attachURL("/v7/webadmin/local_mailboxes.fts?id=" + currentDomain);
    }
    if (id == "tab_general") 
    {
        //var l = propertyTabs.cells(id).attachLayout("2E")
        var l = propertyTabs.cells(id)
        l.attachURL("/v7/webadmin/local_general.fts?id=" + currentDomain);
    }
    if (id == "tab_signature") 
    {
        //var l = propertyTabs.cells(id).attachLayout("2E")
        var l = propertyTabs.cells(id)
        l.attachURL("/v7/webadmin/local_signature.fts?id=" + currentDomain);
    }
    if (id == "tab_filters") 
    {
        var l = propertyTabs.cells(id)
        l.attachURL("/v7/webadmin/local_filters.fts?id=" + currentDomain);
    }
    if (id == "tab_privilages") 
    {
        var l = propertyTabs.cells(id)
        l.attachURL("/v7/webadmin/local_privileges.fts?id=" + currentDomain);
    }
    if (id == "tab_tools") // // migration
    {
        var l = propertyTabs.cells(id)
        l.attachURL("/v7/webadmin/domain_tools.fts?id=" + currentDomain);
    }

    if (id == "b5") // // migration
    {
        var l = propertyTabs.cells(id)
        l.attachURL("/v7/webadmin/local_migration.fts?id=" + currentDomain);
    }
    return true;
}

function mailboxSelect(id) {
    var mbx = mailboxList.getUserData(id, "mailbox")
    parent.parent.openNewTab(mbx,'/v7/webmail/mbx_account.fts?mailbox='+mbx,true,true)
    //rightPane.attachURL("/v7/webadmin/mailboxes/mailbox/index.fts?id=" + id);

}