var editor
var action=""
var uid = ""
var mailbox = ""
var folder = ""
var contact = ""
var theGrid;
var theSendButton;
var toolbar
var sigcontent
var isEmbedded=0

function initForm()
{
    theSendButton=document.getElementById('btnSend')

    dhtmlx.image_path = "/imgs/"

    toolbar = new dhtmlXToolbarObject('theToolbar');
    toolbar.setIconsPath("/imgs/");
    toolbar.addButton('btnSave', 0, tmxlang["_btn_save"],"save.png")
    toolbar.addButtonTwoState('btnPriorityH', 1, tmxlang["_highimportance"], "v7mail/unseen-high.png",null)
    toolbar.addButtonTwoState('btnPriorityL', 2, tmxlang["_lowimportance"], "v7mail/unseen-low.png", null)
    toolbar.addButtonTwoState('btnReadRcpt', 3, tmxlang["_reqreadrcpt"])
    toolbar.attachEvent("onClick", ToolbarClicked);
    toolbar.attachEvent("onStateChange", ToolbarClicked);

    theGrid = new dhtmlXGridObject('addressGrid');
    theGrid.setImagePath("/imgs/"); //path to images required by grid
    theGrid.init(); //initialize grid
    theGrid.setSkin("dhx_skyblue"); //set grid skin
    theGrid.enableEditEvents(true, false, false);
    theGrid.attachEvent("onEditCell", EditAddress);
    theGrid.attachEvent("onXLE", AddressGridLoaded);
    theGrid.loadXML("/v7/webmail/composegrid.fts?mailbox=" + mailbox + "&fid=" + folder + "&uid=" + uid + "&action=" + action+"&to="+contact);
    theGrid.setNoHeader(true);

    editor = new dhtmlXEditor("content");
    editor.init();

    if (action == "")
        editor.setContent(sigcontent)


    if (isEmbedded)
        document.getElementById("btnAttach").display="none"

    resizeEverything();
    setInterval("KeepAlive()", 60000);
}

function KeepAlive() {
    dhtmlxAjax.get("/keepalive.fts?t=" + (new Date()).getTime(), IsAlive)
}
function IsAlive(loader) {
}

function AddressGridLoaded() {
    combo = theGrid.getColumnCombo(1);
    combo.enableFilteringMode("between");
    if (action != "") {
        dhtmlxAjax.get("/v7/axml/read.fts?mbx=" + mailbox + "&fid=" + folder + "&uid=" + uid+"&action="+action, MailContentLoaded);
        editor.setContentHTML("/v7/axml/readbody.fts?mbx=" + mailbox + "&fid=" + folder + "&uid=" + uid+"&action="+action)
    }
    else 
    {
        //theGrid.selectCell(0, 1)
        //theGrid.editCell()
        HideBusy();
        editor.setContent(sigcontent)
        window.setTimeout(function () {
            editor.edWin.focus();
        }, 1);
    }
    window.setTimeout(function () {
        var linkEl = document.createElement("link");
        linkEl.rel = "stylesheet";
        linkEl.type = "text/css";
        linkEl.href = "/cssinsert.css";
        var head = editor.edDoc.getElementsByTagName('head')[0];
        head.appendChild(linkEl);

    }, 5)
    InitDragandDrop()
    dhtmlxEvent(window, "resize", resizeEverything)
    if (action == "" || action == "forward")
        theSendButton.disabled = true;

}


function EditAddress(stage, rId, cInd, nValue, oValue) {
    if (stage==2) {
        if (cInd == 1) 
        {
            nValue = nValue.trim();
            if (nValue.length == 0 && theGRid.getRowIndex(rId)>0)
                theGrid.deleteRow(rId);
        }
        setTimeout("CheckCellEditor()", 100);
    }
    return true;
}

function isValidEmail(address) {
    var parts = address.split(' ')
    if (parts.length == 1)
        return utility.isAddress(address);
    for (i = 0; i < parts.length; i++) {
        if (parts[i].indexOf('@') != -1) {
            var addr = parts[i];
            if (addr.indexOf('<')==0 && addr.indexOf('>')==addr.length-1)
            {
                return utility.isAddress(addr.slice(1,addr.length-2))
            }
        }
    }
    return false;
}

function CheckCellEditor() {
    theGrid.clearSelection();
    var hasError=false;
    // look to see if there are any cells that have a blank to/cc entry
    // and if there are any empty cells for the editor
    // we delete any blank ones
    isLoading = true; // prevent recursion if we update a cell
    var size = theGrid.getRowsNum()
    var foundEmpty = false
    var foundTo = false; ;
    theGrid.forEachRow(function (id) { // function that gets id of the row as an incoming argument
        if (id >= rowId)
            rowId=id+1
        // here id - id of the row
        var dataCell = theGrid.cells(id, 1);
        var val = dataCell.getText().trim()
        var state = theGrid.cells(id, 0).getValue().trim()
        if (val.length == 0)
            foundEmpty = true;
        else {
            // check its valid
            var val3=val
            val3=val3.replace("[", "<")
            val3=val3.replace("]",">")
            if (isValidEmail(val3)) {
                dataCell.setBgColor('transparent');
                val2 = val.replace(/"/g, "")
                if (val2 != val)
                    dataCell.setValue(val2)
            }
            else {
                dataCell.setBgColor('#ffcccc');
                hasError = true;
            }
        }
        if (state.length == 0) {
            if (size == 0)
                theGrid.cells(id, 0).setValue("to")
            else
                theGrid.cells(id, 0).setValue("cc")
        }
        else {
            if (state == "to")
                foundTo = val!="";
        }
    })

    if (!foundEmpty) {
        if (size == 0) {
            theGrid.addRow(rowId++, "to,", rowId);
            theGrid.selectCell(rowId++, 1)
            theGrid.editCell()
        }
        else
            theGrid.addRow(rowId++, "cc,", rowId);
    }
    theGrid.setSizes();
    if (!foundTo)
        hasError = true;
    theSendButton.disabled = hasError;
}

function SetItemSize(el, x, y) {
    var elm = document.getElementById(el);
    elm.style.width = x + "px";
    if (typeof(y)!=undefined)
        elm.style.height = y+"px";
}
function resizeEverything() {
    var maxw = document.getElementById("mainbox").clientWidth;
    var maxh = document.getElementById("mainbox").clientHeight;
    SetItemSize('addressGrid', maxw - 420);
    SetItemSize('subjectInput', maxw - 117);
    SetItemSize('content', maxw - 12,maxh-200);
    editor._doOnResize()


    return;
    resizeBox(document.getElementById('addressGrid'), 0, -1)
    resizeBox(document.getElementById('content'), 10, 5)
    return;
    resizeBox(document.getElementById('mainContainer'), 15, 40)
    resizeBox(document.getElementById('header'), 5, -1)
    resizeBox(document.getElementById('subjectInput'), 10, -1)
    resizeBox(document.getElementById('dropbox'), 10, -1)
}

function resizeBox(el,x,y)
{
    var parent = el.parentNode;
    if (parent && el.style) {
        if (y != -1) {
            var h = parent.clientHeight - el.offsetTop;
            h -= y;
            el.style.height = h + "px";
        }
        var w = parent.clientWidth;
		w-=x;
        el.style.width=w+"px"
		}
}


function AppendFileNode(id, data) {
    var datastore = document.getElementById("uploads");
    node = document.createElement("input")
    node.id = id;
    node.name = id;
    node.type = "hidden"
    node.value=data
    datastore.appendChild(node);
}

var fileCount = 0;
function AttachFileData(filename, type, encoding, data) {
    AppendFileNode("file_name_" + fileCount, filename);
    AppendFileNode("file_type_" + fileCount, type);
    AppendFileNode("file_encoding_" + fileCount, encoding);
    if (data.indexOf("ref:") == 0)
        AppendFileNode("file_ref_" + fileCount, data);
    else
        AppendFileNode("file_data_" + fileCount, data);

    // add the button
    var btn = document.createElement("button")
    btn.innerHTML = filename;
    btn.id = "attach_" + fileCount;
    btn.className = "deleteAttach";
    btn.onclick = deleteAttachment;
    document.getElementById("dropbox").appendChild(btn);
    fileCount++
    document.getElementById("filecount").value = fileCount;
}

function AttachFile() {
    document.getElementById('newfile').click()
}

function deleteAttachment() {
    var filenum = this.id.slice(7);
    var parent = document.getElementById("dropbox");
    parent.removeChild(this);
    var datastore = document.getElementById("uploads");
    var el = document.getElementById("file_name_" + filenum);
    datastore.removeChild(el);
    el = document.getElementById("file_type_" + filenum);
    datastore.removeChild(el);
    el = document.getElementById("file_encoding_" + filenum);
    datastore.removeChild(el);
    el = document.getElementById("file_data_" + filenum);
    if (el)
        datastore.removeChild(el);
    el = document.getElementById("file_ref_" + filenum);
    if (el)
        datastore.removeChild(el);

}

var rowId = 1;
function CleanAddress(address) {
    address = address.trim()
    address = address.replace(/"/g, '')
    address = address.trim()
    if (address.indexOf('<') == 0 && address.indexOf('>')==address.length - 1){
        address = address.slice(1, address.length - 1);
        address = address.replace(/ /g, '')
    }
    if (address.indexOf('[') == 0 && address.indexOf(']')==address.length - 1){
        address = address.slice(1, address.length - 1);
        address = address.replace(/ /g, '')
    }
    address = address.trim()
    return address;
}

function ProcessAddressDisplay(type, line) {
    return
    line = line.trim()
    if (line.length > 0) {
        var addresses = line.split(",")
        for (i = 0; i < addresses.length; i++) {
            var address = CleanAddress(addresses[i]);
            theGrid.addRow(rowId++, type + "," + address, rowId);
        }
    }
}


function MailContentLoaded(loader) {
    // initialise the main components of the view
    var xml = loader.xmlDoc.responseXML;
    var from = GetXmlVal(xml.getElementsByTagName('from')).trim()
    var to = GetXmlVal(xml.getElementsByTagName('to')).trim()
    var cc = GetXmlVal(xml.getElementsByTagName('cc')).trim()
    var bcc = GetXmlVal(xml.getElementsByTagName('bcc')).trim()
    var replyto = GetXmlVal(xml.getElementsByTagName('replyto')).trim()
    var subject = GetXmlVal(xml.getElementsByTagName('subject')).trim()
    var prepend = "";

    if (action == "reply" || action == "replyall") {
        prepend = tmxlang["_re"];
        if (replyto.length==0)
            ProcessAddressDisplay("to", from);
        else
            ProcessAddressDisplay("to",replyto);
    }
    if (action == "replyall") {
        prepend = tmxlang["_re"];
        ProcessAddressDisplay("cc", to);
        ProcessAddressDisplay("cc", cc);
    }
    if (action == 'forward')
        prepend = "fwd" //tmxlang["_fwd"];

    if (action == 'continue') {
        ProcessAddressDisplay("to", to);
        ProcessAddressDisplay("cc", cc);
        ProcessAddressDisplay("bcc", bcc);
    }

    val = GetXmlVal(xml.getElementsByTagName('subject'))
    if (prepend.length > 0) {
        prepend += ":";
        if (val.toLowerCase().indexOf(prepend.toLowerCase())==-1)
            val=prepend+val;
    }
    document.getElementById("subjectInput").value = val

    // now 
    var attach = xml.getElementsByTagName('attachment')
    for (var i = 0; i < attach.length; i++) {
        var node = attach[i];
        var filename = GetXmlVal(node.getElementsByTagName('filename'))
        var type = GetXmlVal(node.getElementsByTagName('type'))
        var encoding = GetXmlVal(node.getElementsByTagName('encoding'))
        var data = GetXmlVal(node.getElementsByTagName('data'))
        AttachFileData(filename, type, encoding, data);
    }
    setTimeout("CheckCellEditor()", 200);
    HideBusy();
}

function HideBusy() {
    document.getElementById("busyFrame").style.display = "none";
    document.getElementById("busyImage").style.display = "none";
}

function ShowBusy() {
    document.getElementById("busyFrame").style.display = "block";
    document.getElementById("busyImage").style.display = "block";
}

function Upload() {
    document.getElementById('submitattach').click()
    ShowBusy();
}

function StartUpload() {
}

function StringtoXML(text) {
    if (window.ActiveXObject) {
        var doc = new ActiveXObject('Microsoft.XMLDOM');
        doc.async = 'false';
        doc.loadXML(text);
    } else {
        var parser = new DOMParser();
        var doc = parser.parseFromString(text, 'text/xml');
    }
    return doc;
}

function FinishUpload(returnData) {
    var XmlDoc = StringtoXML(returnData);
    var node=XmlDoc.getElementsByTagName("attachment")[0]
    var filename = GetXmlVal(node.getElementsByTagName('filename'))
    var type = GetXmlVal(node.getElementsByTagName('type'))
    var encoding = GetXmlVal(node.getElementsByTagName('encoding'))
    var data = GetXmlVal(node.getElementsByTagName('data'))
    AttachFileData(filename, type, encoding, data);
    HideBusy();
}

var addrCount = 0;
function AttachAddressData(type, addr) {
    name = "addrtype" + addrCount;
    var datastore = document.getElementById("addresses");
    node = document.createElement("input")
    node.id = name;
    node.name = name;
    node.type = "hidden"
    node.value=type
    datastore.appendChild(node);
    name = "addrval" + addrCount;
    node = document.createElement("input")
    node.id = name;
    node.name = name;
    node.type = "hidden"
    node.value=addr
    datastore.appendChild(node);
    addrCount++;
}

function TransferAddressData(id) {
        var dataCell = theGrid.cells(id, 1);
        var addr = dataCell.getText().trim()
        var type = theGrid.cells(id, 0).getValue().trim()
        if (addr.length > 0) {
            addr=addr.replace("[", "<")
            addr = addr.replace("]", ">")
            addr = addr.replace(";", "");
            AttachAddressData(type, addr);
        }
}

var composed = false;
function PreProcessForm() {
    if (composed)
        return;
    // do the sender
    var e=document.getElementById("sel_sender");
    var val = e.options[e.selectedIndex].value;
    document.getElementById("sender").value = val;

    theGrid.forEachRow(TransferAddressData)
    var subject = document.getElementById('subjectInput').value
    document.getElementById('subjectLine').value = subject

    var message = editor.getContent()
    // the returned form may have a buch of crap in it
    // where it sticks the style sheet into the body after the subject line (duh!)
    // so we need to clean it up
    var theIf = message.indexOf("<!--[if")
    while (theIf != -1) {
        theEndIf = message.indexOf("<![endif]-->", theIf)
        if (theEndIf != -1)
            message = message.slice(0, theIf) + message.slice(theEndIf + 12);
        else break;
        theIf = message.indexOf("<!--[if")
    }
    var theMeta = message.indexOf("<meta ")
    while (theMeta != -1) {
        var theEnd = message.indexOf(">", theMeta + 1)
        if (theMeta != -1)
            message = message.slice(0, theMeta) + message.slice(theEnd + 1);
        else break;
        theMeta = message.indexOf("<meta ")
    }
    var theStyle= message.indexOf("<style>")
    while (theStyle != -1) {
        var theEnd = message.indexOf("</style>", theStyle + 1)
        if (theStyle != -1)
            message = message.slice(0, theStyle) + message.slice(theEnd + 8);
        else break;
        theStyle = message.indexOf("<style>")
    }
    message=message.replace("<!--cssinsert-->","")
    document.getElementById('messageBody').value = message
    composed = true;
}

function OnSend() {
    // we can only click this is the UI has validated the inputs
    // copy the address fields from the grid into the from buffer
    ShowBusy();
    PreProcessForm();
    document.getElementById('submitSend').click();
}

function StartSend() {
}

function FinishSend(returnData) {
    if (returnData == "ok")
        window.close()
    else {
        alert("Error returned:\n" + returnData);
        HideBusy();
    }
}

function ToolbarClicked(id) {
    if (id == "btnSave") {
        // save as draft
        ShowBusy()
        PreProcessForm();
        document.getElementById("action").value = "save";
        document.getElementById('submitSend').click();
    }
    if (id == "btnPriorityH") {
        if (toolbar.getItemState(id)) {
            document.getElementById("priority").value = "1";
            toolbar.setItemState("btnPriorityL", false)
            toolbar.setItemState("btnPriorityH", true)
        }
        else {
            document.getElementById("priority").value = "3";
            toolbar.setItemState("btnPriorityH", false)
        }
    }
    if (id == "btnPriorityL") {
        if (toolbar.getItemState(id)) {
            document.getElementById("priority").value = "5";
            toolbar.setItemState("btnPriorityH", false)
            toolbar.setItemState("btnPriorityL", true)
        }
        else {
            document.getElementById("priority").value = "3";
            toolbar.setItemState("btnPriorityL", false)
        }
    }
    if (id == 'btnReadRcpt') {
        if (toolbar.getItemState(id))
            document.getElementById("readrcpt").value = "true";
        else
            document.getElementById("readrcpt").value = "";
    }
}