
mailView = {
    main_layout:null,
    tree:null,
    mailToolbar:null,
    mailGrid: null,
    mailStyle:3,
    treePane:null,
    mailPane: null,
    mailPreview: null,
    mailList:null,
    leftToolbar:null,
    sortIndex:2,
    sortDirection:"asc",
    sortType:",",
    currentMailbox:null,
    currentFolder:null,
    currentType:null,
    currentRights: "",
    moveids:',',
    movefolder:'',
    ignoreDrag:true,
    moveTimout:0,
    maxRowId: 0,
    messagePane:null,
    currentRowId : -1,
    checkTimer:null,
    refresh : false,
    nextUid: [],
    lastModified: "",
    invalidateDisplay:true,
    messageList:[]
}

//var snd = new Audio("/newmail.wav"); // buffers automatically when created

var snd

mailView.Init = function (layout) {
    snd = document.createElement("audio")
    snd.src = "/newmail.wav";

    mailView.currentMailbox = accountView.account;
    mailsort = accountView.GetPreference("mailsort") || ""
    var st = mailsort.split(",")
    if (st.length == 3) {
        mailView.sortIndex = st[0]
        mailView.sortType = st[1]
        mailView.sortDirection = st[2]
    }
    mailView.mailStyle = accountView.GetPreference("mailstyle")
    if (mailView.mailStyle == undefined)
        mailView.mailStyle = 0;
    mailView.main_layout = layout; // new dhtmlXLayoutObject(document.body, '2U');
    mailView.main_layout.setAutoSize("b", "b")
    mailView.treePane = mailView.main_layout.cells('a');
    mailView.treePane.setWidth('300');
    mailView.treePane.setText(tmxlang["_mail"])

    mailView.leftToolbar = mailView.treePane.attachToolbar();
    mailView.treePane.showHeader();

    mailView.leftToolbar.addButton("refresh", 0, '', '/images/recur.gif')
    mailView.leftToolbar.setItemToolTip("refresh", tmxlang["_refresh"])
    mailView.leftToolbar.addSeparator('s1', 0);
    mailView.leftToolbar.addButton("share", 0, "", '/images/group.png', '/images/group_dis.png')
    mailView.leftToolbar.setItemToolTip("share", tmxlang["_share"])
    mailView.leftToolbar.addSeparator('s1', 0);
    mailView.leftToolbar.addButton("fav", 0, '', '/imgs/folderfavourite.png')
    mailView.leftToolbar.setItemToolTip("fav", tmxlang["_btn_favourite"])
    mailView.leftToolbar.addSeparator('s1', 0);
    mailView.leftToolbar.addButton("ren", 0, '', '/imgs/folderrename.png')
    mailView.leftToolbar.setItemToolTip("ren", tmxlang["_btn_rename"])
    mailView.leftToolbar.addButton("add", 0, '', '/imgs/folderadd.png')
    mailView.leftToolbar.setItemToolTip("add", tmxlang["_btn_add"])
    mailView.leftToolbar.addSeparator('s1', 0);
    mailView.leftToolbar.addButton("del", 0, '', '/imgs/folderdelete.png')
    mailView.leftToolbar.setItemToolTip("del", tmxlang["_btn_delete"])
    mailView.leftToolbar.setAlign('right')
    mailView.leftToolbar.disableItem("share");
    mailView.leftToolbar.attachEvent("onclick", mailView.OnLeftToolbar);


    mailView.tree = mailView.treePane.attachTree('1');
    mailView.tree.setIconsPath('/imgs/');
    mailView.tree.enableDragAndDrop('1', true);
    mailView.tree.setStdImages("folderclosed.gif", "folderopen.gif", "folderChildren.png");
    mailView.tree.attachEvent("onSelect", mailView.SelectFolder);
    mailView.tree.attachEvent("onDrag", mailView.DragIntoTree);
    mailView.treePane.progressOn();
    //top.SetFolderCallbackFn("mail", mailView.currentMailbox, mailView.UpdateDirectory);

    mailView.mailPane = mailView.main_layout.cells('b');
    mailView.mailPane.hideHeader()
    mailView.mailToolbar = mailView.mailPane.attachToolbar()
    mailView.mailToolbar.attachEvent("onClick", mailView.MailButtonClicked);
    mailView.mailToolbar.attachEvent("onStateChange", mailView.MailButtonClicked);
    mailView.mailToolbar.addButton("btn_compose", null, tmxlang["_new"], '/images/buttons/icons/compose.gif')
    mailView.mailToolbar.addSeparator('ts1', null);
    mailView.mailToolbar.addButton("btn_delete", null, tmxlang["_btn_delete"], '/images/buttons/icons/purge.gif')
    mailView.mailToolbar.addButton("btn_purge", null, tmxlang["_btn_purge"], '/imgs/trash.gif')
    mailView.mailToolbar.addSeparator('ts4', null);
    mailView.mailToolbar.addButton("btn_unread", null, '', '/imgs/v7mail/unseen.png')
    mailView.mailToolbar.setItemToolTip("btn_unread", tmxlang["_markunread"]);
    mailView.mailToolbar.addButton("btn_flag", null, '', '/imgs/v7mail/flag.png')
    mailView.mailToolbar.setItemToolTip("btn_flag", tmxlang["btn_flag"]);
    mailView.mailToolbar.addSeparator('ts2', null);
    mailView.mailToolbar.addButtonTwoState("btn_style0", null, '', '/imgs/v7mail/preview-low.png')
    mailView.mailToolbar.setItemToolTip("btn_style0", tmxlang["_btn_widelayout"]);
    mailView.mailToolbar.addButtonTwoState("btn_style1", null, '', '/imgs/v7mail/preview-right.png')
    mailView.mailToolbar.setItemToolTip("btn_style1", tmxlang["_btn_narrowlayout"]);
    mailView.mailToolbar.addButtonTwoState("btn_style2", null, '', '/imgs/v7mail/preview-off.png')
    mailView.mailToolbar.setItemToolTip("btn_style2", tmxlang["_btn_nopreview"]);
    mailView.mailToolbar.addSeparator('ts3', null);
    mailView.mailToolbar.addButton("btn_refreshmail", null, tmxlang["_btn_refresh"], '/images/recur.gif')
    mailView.mailToolbar.setItemToolTip("btn_refreshmail", tmxlang["_btn_refresh"]);



    top.SetEvent("UPDATEFOLDER", mailView.UpdateDirectory)
    top.SetEvent("RIGHTSCHANGED", mailView.RefreshDirectory)

    setInterval('mailView.UpdateCheck()',5000)
}


mailView.DragIntoTree=function(dId, lId, sObject, tObject) {
    if (!mailView.ignoreDrag) {
        if (mailView.moveTimout) {
            clearTimeout(mailView.moveTimout);
        }
        mailView.moveids += dId + ','
        mailView.movefolder = NormaliseFolderId(lId);
        mailView.moveTimout = setTimeout("mailView.DoMessageMove()", 200);
    }
    return false;
}

mailView.DoMessageMove=function(){
    //alert("Moving messages " + moveids + "\n to folder" + movefolder);
    action = "move"
    if (top.isCtrl)
        action="copy"
    if (mailView.moveids != "," && mailView.movefolder != "" && mailView.movefolder != "1")
        dhtmlxAjax.get('/v7/json/messagelist.fts?fid=' + NormaliseFolderId(mailView.currentFolder) + '&skip=1&mailbox=' + accountView.account + '&mailstyle=' + mailView.mailStyle + '&action='+action+'&target=' + NormaliseFolderId(mailView.movefolder) + '&ids=,' + mailView.moveids, mailView.UpdateCheck);
    mailView.moveids = ','
    mailView.movefolder = '';
}

mailView.DirectoryUpdated = function () {
    // rebuild the tree
    var currentFolder = accountView.GetPreference("selected.mail");
    if (mailView.currentFolder != currentFolder) {
        mailView.currentFolder = currentFolder;
        mailView.messageList = []
    }
    var favourites = accountView.GetPreference("favfolders") || "";
    mailView.tree.deleteChildItems("1")
    var fakeid = 100
    var includedAlready = []
    for (i = 0; i < accountView.directory.length; i++) {
        var itemMap = [] // map folders to id's so we can populate the tree in style
        var account = accountView.directory[i];
        if ((account.account.indexOf("~") != -1 || includedAlready[account.account] == "1")) // group or system
            continue;
        if (account.type == 11)
        { 
            // group mailbox
            // check the reasons to reject it
            if (account.extendedmode0 != "project")
                continue;
            if (account.userdata != "manager")
            { 
                if (accountView.address!=account.account && account.extendedmode1=="")
                    continue;
            }
        }
        includedAlready[account.account] = "1"
        itemMap["/folder"] = account.uid;
        mailView.tree.insertNewChild("1", account.uid, account.account);
        var img = "/projects/user.png"
        if (account.extendedmode0 == "project")
            img = "/projects/project.png"
        if (account.userdata == "manager" && account.type==11)
            img = "/projects/manager.png"
        mailView.tree.setItemImage(account.uid, img, img)

        for (j = 0; j < account.items.length; j++) {
            var item = account.items[j]
            if (item.type != 116)
                continue;
            if ((item.name == "//Folder" || item.path.indexOf("~") != -1) && (item.name != "//Quarantine"))
                continue;
            // find the parent id
            var parentId = account.uid
            var path = item.path.split('/')
            if (item.name == "//Quarantine")
                path = [[""], [""], ["Folder"], ["Shared"], ["Quarantine"]]
            path.reverse()
            path.pop()
            path.pop()
            var subPath = "";
            var node = path.pop();
            var lastNode = "---"
            while (path.length) {
                subPath += "/" + node
                lastNode = node;
                node = path.pop();
                var theId = itemMap[subPath.toLowerCase()]
                if (theId == undefined) {
                    // this part of the tree is missing
                    fakeid++
                    theId = account.uid + "_" + fakeid;
                    itemMap[subPath.toLowerCase()] = theId;
                    mailView.tree.insertNewChild(parentId, theId, lastNode)
                }
                parentId = theId
            }

            parentId = itemMap[subPath.toLowerCase()];
            mailView.tree.insertNewChild(parentId, item.id, node)
            mailView.tree.setUserData(theId, "path", item.path);
            subPath += "/" + node;
            itemMap[subPath.toLowerCase()] = item.id
            if (!mailView.currentFolder && item.name == "//Inbox" && i == 0)
                mailView.currentFolder = item.id
            if (favourites.indexOf(item.id + ";") != -1) {
                fakeid++
                theId = "fav_" + fakeid;
                mailView.tree.insertNewChild("1", theId, " " + node + " in " + account.account, undefined, 'folderfavourite.png')
                mailView.tree.setUserData(theId, "favid", item.id);
            }

        }

    }
    mailView.tree.closeAllItems("1")
    mailView.treePane.progressOff();
    mailView.tree.sortTree("1", "ASC", true)
    mailView.maxRowId = 0
    mailView.currentRowId = -1
    mailView.tree.selectItem(mailView.currentFolder);
}


mailView.OnLeftToolbar = function (id) {
    if (id == "refresh")
        accountView.RefreshDirectory();

    if (id == "share") {
        // open the share window
        top.OpenDialog(700, 400, tmxlang["_share"], '/v7/utility/share.fts?id=' + mailView.currentFolder);
    }
    if (id == "del") {
        // need to confirm the delete
        var text = mailView.tree.getItemText(mailView.currentFolder);
        var r = confirm(tmxlang["_confirm_delete"] + "\n" + text);
        if (r == true) {
            mailView.treePane.progressOn();
            //top.FolderModify(rootMailbox, 1, '&delete=' + mailView.currentFolder)
            //tree.loadXML('/v7/axml/folderlist.fts?type=1&mailbox=' + currentMailbox + '&delete=' + currentFolder, FoldersLoaded);
            accountView.RefreshDirectory('&delete=' + mailView.currentFolder);
        }
    }
    if (id == "add") {
        var path = "/"
        if (mailView.currentFolder.length > 15) {
            item = accountView.ItemFromId(mailView.currentFolder);
            if (item)
                path = item.path
            else {
                path = mailView.tree.getUserData(mailView.currentFolder, "path")

            }
            path = path.slice(8)
        }
        if (path.toLowerCase() == "/inbox")
            path = "/"
        var newPath = prompt("New folder in\n" + path, "");
        if (newPath != null && newPath != "") {
            if (path == "/") path = ""
            newPath = "//folder" + path + '/' + newPath;
            mailView.treePane.progressOn();
            //top.FolderModify(rootMailbox, 1, )
            //tree.loadXML('/v7/axml/folderlist.fts?type=1&mailbox=' + currentMailbox+'&folder='+currentFolder+'&create='+newPath, FoldersLoaded);
            accountView.RefreshDirectory('&parent=' + mailView.currentFolder + '&create=' + newPath);
        }
    }
    if (id == "ren") {
        var newPath = prompt(tmxlang["_new_name"], "");
        if (newPath != null && newPath != "") {
            mailView.treePane.progressOn();
            accountView.RefreshDirectory('&parent=' + mailView.currentFolder + '&rename=' + newPath);
        }
    }
    if (id == "fav") {
        // favourite this
        //treePane.progressOn();
        var fav = accountView.GetPreference("favfolders") || "";
        var key = mailView.currentFolder + ";"
        if (fav.indexOf(key) != -1)
            fav = fav.replace(key, "");
        else
            fav += key;
        accountView.SetPreference("favfolders", fav);

        mailView.DirectoryUpdated();
        //tree.loadXML('/v7/axml/folderlist.fts?type=1&mailbox=' + currentMailbox + '&addfav=' + currentFolder, FoldersLoaded);
        //DelayedLoad();
    }
}

function NormaliseFolderId(id) {
    if (id.slice(0, 3) == "fav") // its a favourite so look it up
        id=mailView.tree.getUserData(id,"favid")
    return id;
}

mailView.EnableToolbarOptions = function (del, add, rename, share, fav) {
    if (del) {
        mailView.leftToolbar.enableItem("del")
    }
    else {
        mailView.leftToolbar.disableItem("del")
    }

    if (share)
        mailView.leftToolbar.enableItem('share')
    else
        mailView.leftToolbar.disableItem('share')

    if (add)
        mailView.leftToolbar.enableItem('add')
    else
        mailView.leftToolbar.disableItem('add')

    if (rename)
        mailView.leftToolbar.enableItem('ren')
    else
        mailView.leftToolbar.disableItem('ren')

    if (fav)
        mailView.leftToolbar.enableItem('fav')
    else
        mailView.leftToolbar.disableItem('fav')
}



var mailGrid

mailView.SelectFolder = function (id) {

    mailView.ignoreDrag = true;
    mailView.currentFolder = id;
    if (id.length == 15) {
        // this is a top level folder, so we cant select it
        mailView.EnableToolbarOptions(false, true, false, false, false);
        mailView.ignoreDrag = true;
        return;
    }
    clearTimeout(mailView.checkTimer);

    mailView.mailPane.progressOn();
    mailView.currentFolder = NormaliseFolderId(id);

    if (typeof (mailView.nextUid[mailView.currentFolder]) == undefined)
        mailView.nextUid[mailView.currentFolder] = 0;

    accountView.SetPreference("selected.mail", id);

    // find the folder in the directory
    var path = ""
    var project = false;

    for (i = 0; i < accountView.directory.length && path == ""; i++)
        for (j = 0; j < accountView.directory[i].items.length && path == ""; j++) {
            if (accountView.directory[i].items[j].id == mailView.currentFolder) {
                mailView.theAccount = accountView.directory[i]
                mailView.currentMailbox = accountView.directory[i].uid
                mailView.currentRights = accountView.directory[i].items[j].rights
                if (accountView.directory[i].extendedmode0 == "project") {
                    project = true;
                }
                mailView.currentType = accountView.directory[i].items[j].type
                path = accountView.directory[i].items[j].path
            }
        }

    if (path == "//Folder/Shared/~ftgate/admin/Quarantine") {
        // quarantine
        mailView.main_layout.cells('b').attachURL("/v7/webadmin/filters/quarantine.fts?limited=1");
        mailView.mailToolbar.forEachItem(function (id) { mailView.mailToolbar.hideItem(id) })
        return;
    }
    else
        mailView.mailToolbar.forEachItem(function (id) { mailView.mailToolbar.showItem(id) })

    if (mailView.theAccount.compose == false)
        mailView.mailToolbar.disableItem("btn_compose")
    else
        mailView.mailToolbar.enableItem("btn_compose")

    if (mailView.theAccount.compose == false) // dont enable other functions for this
    {
        mailView.mailToolbar.disableItem("btn_delete")
        mailView.mailToolbar.disableItem("btn_purge")
        mailView.mailToolbar.disableItem("btn_unread")
        mailView.mailToolbar.disableItem("btn_flag")
    }
    else {
        mailView.mailToolbar.enableItem("btn_delete")
        mailView.mailToolbar.enableItem("btn_purge")
        mailView.mailToolbar.enableItem("btn_unread")
        mailView.mailToolbar.enableItem("btn_flag")
    }
    if (mailView.theAccount.type == 14) {
        mailView.mailToolbar.enableItem("btn_delete")
        mailView.mailToolbar.enableItem("btn_purge")
    }
    isfav = mailView.currentFolder != id
    isshared = path.indexOf("shared") != -1
    isinbox = path.indexOf("//folder/inbox") != -1
    canshare = (mailView.currentRights.indexOf("m") != -1) && !isfav
    canadd = (mailView.currentRights.indexOf("m") != -1) && !isfav
    canren = (mailView.currentRights.indexOf("m") != -1) && !isfav && path != "//Folder/Inbox"
    candel = (mailView.currentRights.indexOf("d") != -1) && !isfav && path != "//Folder/Inbox"
    mailView.EnableToolbarOptions(!isinbox && !isshared && !isfav && candel, canadd && !isshared || mailView.currentRights == "xxx", canren && !isshared && !isinbox, canshare && !isshared, !isshared);
    mailView.ignoreDrag = (mailView.currentRights.indexOf("m") == -1) && (mailView.currentRights.indexOf("w") == -1);

    // the mail window
    if (mailView.invalidateDisplay) {
        var b = mailView.main_layout.cells('b');

        switch (mailView.mailStyle) {
            case 0:
                mailView.rightPane = b.attachLayout('2E');
                mailView.mailList = mailView.rightPane.cells("a")
                mailView.mailPreview = mailView.rightPane.cells("b")
                mailView.mailToolbar.setItemState("btn_style0", true)
                mailView.mailToolbar.setItemState("btn_style1", false)
                mailView.mailToolbar.setItemState("btn_style2", false)

                break;
            case 1:
                mailView.rightPane = b.attachLayout('2U');
                mailView.mailList = mailView.rightPane.cells("a")
                mailView.mailPreview = mailView.rightPane.cells("b")
                mailView.mailToolbar.setItemState("btn_style0", false)
                mailView.mailToolbar.setItemState("btn_style1", true)
                mailView.mailToolbar.setItemState("btn_style2", false)
                break;
            case 2:
                mailView.rightPane = b.attachLayout('1C');
                mailView.mailList = mailView.rightPane.cells("a")
                mailView.mailPreview = null
                mailView.mailToolbar.setItemState("btn_style0", false)
                mailView.mailToolbar.setItemState("btn_style1", false)
                mailView.mailToolbar.setItemState("btn_style2", true)
                break;
        }
        mailView.mailList.setText('Messages');
        mailView.maxRowId = 0
        mailView.currentRowId = -1
        mailView.mailPane.progressOff();


        mailView.myGrid = new GridHandler('myMailGrid');
        if (mailView.mailStyle == 1)
            mailView.myGrid.SetHeader(headerData = [[30, "", ""], [-1, tmxlang["_from"] + '/' + tmxlang["_subject"], "str"], [100, tmxlang["_received"], "date"], [50, "", ""]]);
        else
            mailView.myGrid.SetHeader(headerData = [[30, "", ""], [200, tmxlang["_from"], "str"], [-1, tmxlang["_subject"], "str"], [100, tmxlang["_received"], "date"], [80, tmxlang["_size"], "num"], [50, "", ""]]);
        mailView.myGrid.Init(mailView.mailList);
        mailView.myGrid.SetRowSelect(mailView.onMailRowSelect);
        this.invalidateDisplay = false;
    }
    else {
        mailView.myGrid.ResetData();
        mailView.myGrid.Redraw();
    }


    /*
    mailView.mailGrid.enableDragAndDrop(true);
    mailView.mailGrid.attachEvent("onDragIn", function (dId, tId, sObj, tObj) { });
    mailView.mailGrid.attachEvent("onRowSelect", mailView.onMailRowSelect);
    mailView.mailGrid.attachEvent("onRowDblClicked", mailView.OnMailOpen);
    mailView.mailGrid.attachEvent("onAfterSorting", mailView.ListSorted);
    mailView.mailGrid.attachEvent("OnXLE", mailView.OnMailListLoaded);
    mailView.mailGrid.rowToDragElement = function (id) {

    mailView.mailGrid.enableMultiselect(true);
    if (mailView.mailStyle == 1) {
    mailView.mailGrid.setAwaitedRowHeight(60);
    mailView.mailGrid.setHeader("img:[/imgs/v7mail/unseen.png]," + tmxlang["_from"] + "/" + tmxlang["_subject"] + "," + tmxlang["_received"] + ", , ")
    mailView.mailGrid.setColVAlign("top,top,top,top,top");
    mailView.mailGrid.setInitWidths("40,*,120,20,1")
    mailView.mailGrid.setColAlign("center,left,right,left,left"); //set column values align
    mailView.mailGrid.setColTypes("img,ro,dtICal,ro,ro"); //set column types
    mailView.mailGrid.setColSorting("na,str,SortDateCustom,na,na"); //set sorting
    mailView.mailGrid.enableMultiline(true);
    mailView.mailGrid.attachHeader(',#text_filter,,,')
    }
    else {

    mailView.mailGrid.setHeader(" , ," + tmxlang["_from"] + "," + tmxlang["_subject"] + "," + tmxlang["_received"] + ", " + tmxlang["_size"])
    mailView.mailGrid.setInitWidths("40,30,200,*,120,80")
    mailView.mailGrid.setColAlign("left,left,left,left,right,right"); //set column values align
    mailView.mailGrid.setColTypes("ro,img,ro,ro,dtICal,ro"); //set column types
    mailView.mailGrid.setColSorting("str,na,str,str,SortDateCustom,niceBytes"); //set sorting
    mailView.mailGrid.attachHeader(',,#text_filter,#text_filter,,')
    }
    //mailView.mailGrid.enableSmartRendering(true);
    mailView.mailGrid.init();
    mailGrid = mailView.mailGrid // for the custom sort 

    if (mailView.mailStyle < 2) {
    // the preview window
    mailView.mailPreview = mailView.rightPane.cells('b');
    mailView.mailPreview.hideHeader();
    }
    if (top.HasWebSockets()) {
    top.doSend("MONITORFOLDER " + currentFolder);
    }
    mailView.mailPane.progressOff();
    // pull down the messages
    */
    smState = smStates.SELECTFOLDER;
    setTimeout("mailView.StateMachine()", 100)

}

var smStates = {
    SELECTFOLDER: 0,
    PROCESSFLAGS: 1,
    PROCESSDATA: 2,
    POPULATEFROMCACHE1: 3,
    POPULATEFROMCACHE2: 4,
    POPULATEFROMCACHE3: 5,
    NEWMAILCHECK: 6,
    DONE:7
}
var smState;
var returnedData;
var cacheCounter = 0;
var wantSort = false;


mailView.MakeGridData = function (itemData) {
    var flags = itemData.flags;
    // set the main icon
    isSeen = flags.indexOf("\\seen") != -1
    if (itemData.priority == undefined)
        itemData.priority = "3";
    itemData.priority = itemData.priority.toLowerCase()
    isPriority = itemData.priority.indexOf("high") != -1 || itemData.priority.indexOf("1") != -1 || itemData.priority.indexOf("2") != -1
    //id - row's id
    var style = "font-weight:normal;line-height:150%";
    var icon = "unseen"

    if (isSeen)
        icon = "seen";
    if (itemData.priority.indexOf("3") == -1 && itemData.priority.length > 0 && itemData.priority.indexOf("normal") == -1) {
        if (isPriority)
            icon = icon + "-high"
        else
            icon = icon + "-low"
    }
    if (flags.indexOf("\\answered") != -1)
        icon = icon + "-replied";
    icon = icon + ".png"
    if (!isSeen) {
        style = "font-weight:bold;line-height:150%";
    }


    if (flags.indexOf("\\deleted") != -1)
        style = "color:grey;text-decoration: line-through;";

    var flaggedIcon = '<img src="/imgs/flag-blank.png">'
    if (flags.indexOf("\\flagged") != -1)
        flaggedIcon = '<img src="/imgs/v7mail/flag.png">';

    if (itemData.attachment)
        flaggedIcon += '<img src="/imgs/v7mail/clip.png">';

    var subject = itemData.subject.replace(/\\u/gi, "&#x").replace(/,/g, "&comma;");
    var name = itemData.sendername.replace(/\\u/gi, "&#x").replace(/,/g, "&comma;")
    name = name.replace(/\\/gi, "");
    if (name == "") name = itemData.senderaddress;
    if (!name)
        name = " "
    theData = [];
    theData.push(['<img src="/imgs/v7mail/' + icon + '">', name, subject, FromICalDate(itemData.received), itemData.size, flaggedIcon])
    theData.push(['<img src="/imgs/v7mail/' + icon + '">', name + "<BR>" + subject, FromICalDate(itemData.received), flaggedIcon])
    return theData;
}
mailView.PopulateGrid = function () {
    // dump any old data
    mailView.myGrid.ResetData()
    // push entries into grid
    for (i = 0; i < mailView.messageList.length; i++) {
        var itemData = mailView.messageList[i];
        if (itemData.size == 0)
            continue;

        if (itemData.format==undefined || itemData.format.length==0)
            itemData.format=mailView.MakeGridData(itemData);

        if (mailView.mailStyle == 1) {
            mailView.myGrid.InsertRow(itemData.uid, itemData.format[1], itemData.flags)
        }
        else {
            mailView.myGrid.InsertRow(itemData.uid, itemData.format[0], itemData.flags)
        }
    }
    mailView.myGrid.Redraw();
    if (mailView.mailStyle == 1)
        mailView.myGrid.SortColumn(2);
    else
        mailView.myGrid.SortColumn(3);

}


mailView.StateMachine = function () {
    // this is the state machine for processing the message folder sync operation
    switch (smState) {
        case smStates.SELECTFOLDER:
            top.SetStatus("Updating ...")
            updateQueue = []
            messageKeys = []
            currentQuery = ""
            mailView.mailPane.progressOn();
            if (true) { // load from cache
                if (accountView.localCache[mailView.currentFolder] == undefined) {
                    var cachedData = accountView.Get(mailView.currentFolder)
                    if (cachedData != undefined) {
                        accountView.localCache[mailView.currentFolder] = cachedData
                    }
                }
                if (accountView.localCache[mailView.currentFolder] != undefined) {
                    smState = smStates.POPULATEFROMCACHE1;
                    setTimeout("mailView.StateMachine()", 400);
                    break;
                }
            }
            mailView.messageList = []
            mailView.CheckFlagStatus();
            accountView.localCache[mailView.currentFolder] = mailView.messageList;
            break;

        case smStates.PROCESSFLAGS:
            top.SetStatus("Updating Flags")
            // flag data was returned so we process this
            // into the first pass of the display
            mailView.ProcessUidFlagData();
            mailView.mailPane.progressOff();
            smState = smStates.DONE;
            mailView.CheckForUpdates();
            break;

        case smStates.PROCESSDATA:
            top.SetStatus("Updating Data")
            mailView.ProcessUidData();
            smState = smStates.DONE;
            if (updateQueue.length == 0)
                mailView.CheckForUpdates();
            if (updateQueue.length == 0) {
                mailView.mailPane.progressOff();
            }
            mailView.Done();
            break;

        case smStates.POPULATEFROMCACHE1:
            // get the cachjed messages
            mailView.messageList = accountView.localCache[mailView.currentFolder];
            for (i = 0; i < mailView.messageList.length; i++) {
                var itemData = mailView.messageList[i];
                itemData.pendingUpdate = false;
            }

            mailView.PopulateGrid();
            mailView.mailPane.progressOff()
            smState = smStates.POPULATEFROMCACHE3
            setTimeout("mailView.StateMachine()", 150);
            break;

        case smStates.POPULATEFROMCACHE3:
            top.SetStatus("Checking (" + mailView.messageList.length + ") ")
            mailView.CheckFlagStatus();
            mailView.mailPane.progressOff();
            break;

        case smStates.NEWMAILCHECK:
            // make a request to the server
            top.SetStatus("Checking (" + mailView.currentFolder + ") ")
            if (!top.HasWebSockets())
                dhtmlxAjax.get("/v7/axml/maxuid.fts?fid=" + mailView.currentFolder, mailView.NewMailCheckReturn);
            break;

        case smStates.DONE:
            break;
    }
}

var currentQuery=""
mailView.Done = function () {
    top.SetStatus("Done (" + mailView.messageList.length + ")")
    smState = smStates.DONE;
    if (updateQueue.length > 0 && currentQuery == "") {
        // not done as we want updates.
        var nextQuery = updateQueue.pop();
        currentQuery = nextQuery;
        dhtmlxAjax.get(nextQuery, mailView.ProcessFolderReturnData);
    }
    if (currentQuery != "") {
        // there is a pending update being processed
        smState = smStates.PROCESSDATA
    }
    if (dirty) {
        accountView.Put(mailView.currentFolder, mailView.messageList)
        dirty = false;
        //mailView.PopulateGrid();
    }
}

mailView.UpdateCheck = function () {
    if (smState == smStates.DONE) {
        smState = smStates.NEWMAILCHECK;
        mailView.StateMachine();
    }
}

mailView.CheckFlagStatus = function () {
    dhtmlxAjax.get("/v7/json/messagelist.fts?range=flags&fid=" + mailView.currentFolder, mailView.ProcessFolderReturnData);
    smState = smStates.PROCESSFLAGS;
}

mailView.ProcessReturnedQuery = function () {
    smState = smStates.PROCESSDATA;
    currentQuery = ""
    mailView.StateMachine();
}

mailView.ProcessFolderReturnData = function (loader) {
    var s = loader.xmlDoc.responseText
    returnedData = JSON.parse(s);
    if (currentQuery != "") {
        setTimeout("mailView.ProcessReturnedQuery()", 100)
    }
    else
        mailView.StateMachine();
}



mailView.SelectDefaultMessage = function () {
    try {
        mailView.mailGrid.selectRow(0, true)
    }
    catch (e) { }
    //mailView.DoGrouping();
}

mailView.DoGrouping = function () {
    mailView.mailGrid.forEachRow(function (id) {
        var today = new Date;
        var dt = mailView.mailGrid.getUserData(id, "date")
        var grp = "Today"

        mailView.mailGrid.cells(id, 4).setValue(grp);
    })
    mailView.mailGrid.groupBy(4);
}

mailView.ProcessUidList = function (loader) {
    mailView.mailGrid.enableStableSorting(false);
    var s = loader.xmlDoc.responseText
    returnedData = JSON.parse(s);
    mailView.messageList = returnedData.data;
    mailView.messageList = mailView.messageList.reverse()
    accountView.localCache[mailView.currentFolder] = mailView.messageList;
    mailView.CheckForUpdates(20);
    mailView.mailPane.progressOff();
    //setTimeout('mailView.SelectDefaultMessage()', 50);
}
var dirty = false;
var updateQueue = []
mailView.CheckForUpdates = function (count) {
    if (currentQuery != "" || updateQueue.length > 0)
        return;
    var range = []
    if (!count)
        count = 25
    if (updateQueue.length == 0) {
        for (i = 0; i < mailView.messageList.length; i++) {
            var itemData = mailView.messageList[i]
            if (itemData.size == 0 && itemData.pendingUpdate != true) {
                range.push(itemData.uid)
                itemData.pendingUpdate = true;
            }
            if (mailView.nextUid[mailView.currentFolder] <= itemData.uid)
                mailView.nextUid[mailView.currentFolder] = itemData.uid + 1
        }
    }
    if (range.length > 0) {
        range = range.reverse() // newest messages first
        dirty = true
        mailView.SortAgain()
        while (range.length > 0) {
            var subrange = range.slice(0, count)
            range = range.slice(count)
            subrange = subrange.join(",");
            query = "/v7/json/messagelist.fts?fid=" + mailView.currentFolder + '&range=' + subrange;
            updateQueue.push(query);
            count = 200; // we get the first 25, then bigger groups
        }
        //updateQueue.reverse();
    }
    else {
        // folder is up to date
        // kick of the new mail check
        accountView.localCache[mailView.currentFolder] = mailView.messageList;
        mailView.PopulateGrid();
    }
    mailView.Done();
}

var messageKeys = [];
mailView.ProcessUidData = function (loader) {
    if (returnedData.folderid != mailView.currentFolder.slice(15))
        return; // dont crap on the data
    dirty = true
    var theData = returnedData.data;
    var hasNew = false;

    if (messageKeys.length == 0) {
        for (j = 0; j < mailView.messageList.length; j++)
            messageKeys[mailView.messageList[j].uid] = mailView.messageList[j];
    }
    // populate the main list and update the ui
    for (i = 0; i < theData.length; i++) {
        exists = false;
        var value = messageKeys[theData[i].uid]
        if (value != undefined) {
            exists = true;
            value.flags = theData[i].flags;
            value.priority = theData[i].priority
            value.subject = theData[i].subject
            value.sendername = theData[i].sendername
            value.senderaddress = theData[i].senderaddress
            value.received = theData[i].received
            value.size = theData[i].size
            value.attachment = theData[i].attachment
            value.pendingUpdate = false;
            value.format = mailView.MakeGridData(value)
        }
        else {
            // the uid list
           theData[i].format = []
           mailView.messageList.push(theData[i])
        }
    }
    mailView.PopulateGrid();
}

mailView.ProcessUidFlagData = function () {
    if (returnedData.folderid != mailView.currentFolder.slice(15) || currentQuery != "")
        return; // dont crap on the data
    var theData = returnedData.data;
    dirty = true

    // make a quick key table of the main messages
    var messageKeys = [];
    for (j = 0; j < mailView.messageList.length; j++)
        messageKeys[mailView.messageList[j].uid] = mailView.messageList[j];

    // make a quick key lookup of the returned uids so we can see if any were deleted
    var currentKeys = [];
    var modifiedKeys = []
    // populate the main list and update the ui
    for (i = 0; i < theData.length; i++) {
        currentKeys[theData[i].uid] = "1";
        var value = messageKeys[theData[i].uid];
        if (value != undefined) {
            if (value.flags != theData[i].flags) {
                value.flags = theData[i].flags
                mailView.UpdateRow(value)
                dirty = true;
            }
        }
        else {
            // a new value not in the current display list
            value = {}
            value.uid = theData[i].uid;
            value.flags = theData[i].flags;
            value.priority = ""
            value.subject = ""
            value.sendername = ""
            value.senderaddress = ""
            value.received = "-"
            value.size = 0
            value.pendingUpdate = false;
            mailView.messageList.push(value);
            messageKeys[theData[i].uid] = value
            var item = { id: value.uid,
                data: value.gridData
            }
            dirty = true;
        }
    }

    // look for rows that have been deleted
    for (var key in messageKeys) {
        key = parseInt(key)
        if (currentKeys[key] == undefined) {
            // row was deleted
            // so fix it
            mailView.mailGrid.deleteRow(key);
            dirty = true;
            // find it in the messagelist and remove it
            for (i = 0; i < mailView.messageList.length; i++) {
                if (mailView.messageList[i].uid == key)
                    mailView.messageList.splice(i, 1)
            }
        }
    }

//    if (dirty)
//        mailView.PopulateGrid();
    mailView.CheckForUpdates();
}

function toDate(isoDate) {
    y = parseInt(isoDate.slice(0, 4))
    m = parseInt(isoDate.slice(4, 6))
    d = parseInt(isoDate.slice(6, 8))
    hr = parseInt(isoDate.slice(9, 11))
    mn = parseInt(isoDate.slice(11, 13))
    ss = parseInt(isoDate.slice(13, 15))
    return new Date(y, m-1, d, hr, mn, ss)
}

mailView.toNiceBytes = function (bytes) {
    if (bytes < 1024)
        return bytes;
    else if (bytes < 1024 * 1024)
        return Math.round(bytes / 1024, 1) + "Kb";
    else if (bytes < 1024 * 1024 * 1024)
        return Math.round(bytes / (1024 * 1024), 10) + "Mb";
    else
        return Math.round(bytes / (1024 * 1024 * 1024), 100) + "Gb";
}

var dateCache = []
function SortDateCustom(a, b, order, ra, rb) {
    a1 = dateCache[ra]// mailGrid.getUserData(ra, 'time');
    b1 = dateCache[rb]//mailGrid.getUserData(rb, 'time');
    if (order=="asc")
        return b1-a1
    return a1-b1
}

mailView.ListSorted=function(index, type, direction) {
    mailView.sortType = type;
    mailView.sortIndex = index;
    mailView.sortDirection = direction;
    accountView.SetPreference("mailsort", mailView.sortIndex + "," + mailView.sortType + "," + mailView.sortDirection);
}


mailView.SortAgain = function () {
    if (!wantSort)
        wantSort = true;
}

mailView.DoSort = function () {
    if (mailView.sortIndex) {
        top.SetStatus("Sorting")
        //var dt1 = new Date
        mailView.mailPane.progressOn();
        try {
            //mailView.mailGrid.sortRows(2, "cus", "dec")
            mailView.mailGrid.sortRows(mailView.sortIndex, mailView.sortType, mailView.sortDirection);
        }
        catch (e) { }
        top.SetStatus(" ")
        mailView.mailPane.progressOff();
        //var dt2 = new Date
        //alert("Sort time=" + (dt2.getTime() - dt1.getTime()))
    }
    wantSort = false;
}


mailView.NewMailCheckReturn = function (loader) {
    try {
        var data = loader.xmlDoc.responseText.split("!")
        var uid = parseInt(data[0])
        var lastmodified = data[1]
        var folder = data[2];
        if (folder == mailView.currentFolder) {
            if (uid != mailView.nextUid[mailView.currentFolder]) {
                // there is new mail
                try {
                    if (mailView.nextUid[mailView.currentFolder] != undefined && mailView.nextUid[mailView.currentFolder] != 0) {
                        snd.play();
                        dirty = true;
                    }
                } catch (e) {
                }
                // we want to do an update
                range = []
                for (i = mailView.nextUid[mailView.currentFolder]; i < uid; i++) {
                    range.push(i);
                }
                if (range.length > 0) {
                    range = range.join(",");
                    smState = smStates.PROCESSDATA
                    dirty = true
                    dhtmlxAjax.get("/v7/json/messagelist.fts?fid=" + mailView.currentFolder + '&range=' + range, mailView.ProcessFolderReturnData);
                }
                else
                    mailView.Done()

                mailView.nextUid[mailView.currentFolder] = uid
            }
            else
                if (lastmodified != mailView.lastmodified) {
                    // flag changes
                    mailView.lastmodified = lastmodified;
                    mailView.CheckFlagStatus();
                    dirty = true
                }
                else {
                    mailView.Done()
                }
        }
    }
    catch (e) {
    }
}

mailView.MailButtonClicked = function (id) {
    if (id == 'btn_style1') {
        mailView.mailStyle = 1;
        mailView.sortIndex = 2
        mailView.SelectFolder(mailView.currentFolder);
        accountView.SetPreference("mailstyle", mailView.mailStyle)
    }
    if (id == 'btn_style0') {
        mailView.mailStyle = 0;
        mailView.sortIndex = 3
        mailView.SelectFolder(mailView.currentFolder);
        accountView.SetPreference("mailstyle", mailView.mailStyle)
    }
    if (id == 'btn_style2') {
        mailView.mailStyle = 2;
        mailView.sortIndex = 3
        mailView.SelectFolder(mailView.currentFolder);
        accountView.SetPreference("mailstyle", mailView.mailStyle)
    }
    if (id == 'btn_delete') {
        if (mailView.mailPreview)
            mailView.mailPreview.attachURL("/blank.htm")
        // refresh the page and delete the selected ids
        var checkIds = mailView.mailGrid.getSelectedRowId();
        dirty = true;
        dhtmlxAjax.get('/v7/json/messagelist.fts?fid=' + NormaliseFolderId(mailView.currentFolder) + '&skip=1&mbxid=' + mailView.currentMailbox + '&mailstyle=' + mailView.mailStyle + '&action=del&ids=,' + checkIds, mailView.UpdateCheck);
    }
    if (id == 'btn_unread') {
        var checkIds = mailView.mailGrid.getSelectedRowId();
        dhtmlxAjax.get('/v7/json/messagelist.fts?fid=' + NormaliseFolderId(mailView.currentFolder) + '&skip=1&mbxid=' + mailView.currentMailbox + '&mailstyle=' + mailView.mailStyle + '&action=unseen&ids=,' + checkIds, mailView.UpdateCheck);
    }
    if (id == 'btn_flag') {
        var checkIds = mailView.mailGrid.getSelectedRowId();
        dhtmlxAjax.get('/v7/json/messagelist.fts?fid=' + NormaliseFolderId(mailView.currentFolder) + '&skip=1&mbxid=' + mailView.currentMailbox + '&mailstyle=' + mailView.mailStyle + '&action=flag&ids=,' + checkIds, mailView.UpdateCheck);
    }
    if (id == 'btn_purge') {
        // refresh the page and delete the selected ids
        dhtmlxAjax.get('/v7/json/messagelist.fts?fid=' + NormaliseFolderId(mailView.currentFolder) + '&skip=1&mbxid=' + mailView.currentMailbox + '&mailstyle=' + mailView.mailStyle + '&action=purge', mailView.UpdateCheck);
    }
    if (id == 'btn_compose') {
        window.open("/v7/webmail/mbx_compose.fts?mailbox=" + mailView.currentMailbox);
    }
    if (id == 'btn_reply') {
        var checkIds = mailView.mailGrid.getSelectedRowId();
        if (checkIds.indexOf(",") == -1)
            window.open("/v7/webmail/mbx_compose.fts?mailbox=" + mailView.currentMailbox + "&fid=" + NormaliseFolderId(mailView.currentFolder) + "&uid=" + checkIds + "&action=reply");
    }
    if (id == 'btn_replyall') {
        var checkIds = mailView.mailGrid.getSelectedRowId();
        if (checkIds.indexOf(",") == -1)
            window.open("/v7/webmail/mbx_compose.fts?mailbox=" + mailView.currentMailbox + "&fid=" + NormaliseFolderId(mailView.currentFolder) + "&uid=" + checkIds + "&action=replyall");
    }
    if (id == 'btn_forward') {
        var checkIds = mailView.mailGrid.getSelectedRowId();
        if (checkIds.indexOf(",") == -1)
            window.open("/v7/webmail/mbx_compose.fts?mailbox=" + mailView.currentMailbox + "&fid=" + NormaliseFolderId(mailView.currentFolder) + "&uid=" + checkIds + "&action=forward");
    }
    if (id == 'btn_refreshmail') {
        // dispose of the cache
        // and reload
        mailView.messageList = []
        mailView.CheckFlagStatus();
        accountView.localCache[mailView.currentFolder] = mailView.messageList;
    }
}

mailView.onMailRowSelect = function (id) {
    if (mailView.currentRowId != id && mailView.mailPreview) {
        mailView.currentRowId = id;
        mailView.mailPreview.attachURL("/v7/webmail/readmessage.fts?mailbox=" + mailView.currentMailbox + "&fid=" + NormaliseFolderId(mailView.currentFolder) + "&uid=" + id + "&hdr=1&c=" + mailView.theAccount.compose)
    }
}

mailView.OnMailOpen=function(rid, cind) {
    mailView.currentRowId = rid;
    var flags=mailView.mailGrid.getUserData(rid,"flags")
    if (flags.indexOf("\\draft") != -1) 
        // open the compose window
        window.open("/v7/webmail/mbx_compose.fts?mailbox=" + mailView.currentMailbox + "&fid=" + NormaliseFolderId(mailView.currentFolder) + "&uid=" + rid + "&action=continue");
    else
        window.open("/v7/webmail/readmessage.fts?mailbox=" + mailView.currentMailbox + "&fid=" + NormaliseFolderId(mailView.currentFolder) + "&uid=" + rid + "&hdr=1&c=" + mailView.theAccount.compose)

}

