﻿
var theGridList=[]
var theGridSortColumn = 0

function GridHandler(gridId) {
    theGridList[gridId] = this;
    this._self="theGridList['"+gridId+"']"
    this._gridId = gridId;
    this._headerData=[];
    this._theHeader="";
    this._fixedWidth=0;
    this._rowData = [];
    this._filter = "";
    this._width = 0;
    this._onRowSelect = null;
    this._varWidth = 0;

    this.SetHeader = function (headerData) {
        if (headerData.length == 0) {
            // test with default data
            headerData = [[5, ""], [-1, tmxlang["_subject"]], [100, tmxlang["_received"]], [20, ""]]
        }
        this._headerData = headerData;
        // now build the header and container area
        var theTable = ''
        var height = mailView.mailList.getHeight();
        var width = mailView.mailList.getWidth();
        // create the header
        theTable += '<div class="gridbox gridbox_dhx_skyblue" style="width:100%;height:100%" id="' + gridId + '">'
        theTable += '<div class="xhdr" style="height: 55px; overflow: hidden; position: relative;" >'
        theTable += '<table class="hdr" style="width: 100%; table-layout: fixed; margin-right: 20px; padding-right: 20px;" cellpadding="0" cellspacing="0">'
        theTable += '<tbody>'
        theTable += '<tr style="height: auto;">'
        // how big are the fixed columns
        this._fixedWidth = 0
        for (var i = 0; i < this._headerData.length; i++) {
            if (this._headerData[i][0] != -1)
                this._fixedWidth += this._headerData[i][0]
        }
        // column size control
        this._varWidth=width - this._fixedWidth;
        for (var i = 0; i < this._headerData.length; i++) {
            if (this._headerData[i][0] != -1)
                theTable += '<th style="height: 0px; width:' + this._headerData[i][0] + 'px;max-width:' + this._headerData[i][0] + 'px;"></th>'
            else
                theTable += '<th style="height: 0px; width: ' + this._varWidth + 'px;max-width:' + this._varWidth + 'px;"></th>'

        }
        theTable += '<th style="height: 0px; width: 20px;"></th></tr>'
        // column header
        theTable += '<tr>'
        for (var i = 0; i < this._headerData.length; i++) {
            if (this._headerData[i][1]!="")
                theTable += '<td style="cursor: default;"><div class="hdrcell" onclick="' + this._self + '.SortColumn(' + i + ')">' + this._headerData[i][1] + '</div></td>'
            else
                theTable += '<td style="cursor: default;"><div class="hdrcell"></div></td>'

        }
        theTable += '<td></td></tr>'
        // column sorting
        theTable += '<tr>'
        for (var i = 0; i < this._headerData.length; i++) {
            theTable += '<td style="cursor: default;"><div class="hdrcell">'
            if (this._headerData[i][2]=="str")
                theTable+='<input id="' + this._self + '_Filter" type="text" style="margin:0px;padding:0px;width:' + this._varWidth + 'px" onkeyup="' + this._self + '.FilterGrid(this.value,'+i+')" value="' + this._filter + '">'
            theTable+='</div></td>';
        }
        theTable += '</tr>'
        theTable += '</tbody></table></div>'
        // data container
        theTable += '<div style="width:100%;height:' + (height - 81) + 'px;overflow-y:scroll;overflow-x:hidden;font-family:tahoma" id="' + gridId + '_Content">'
        theTable += '&nbsp;</div>';
        this._theHeader = theTable;
    }
    this.Init = function (dhtmlxcontainer) {
        // insert into the container
        this._width = dhtmlxcontainer.getWidth();
        dhtmlxcontainer.attachHTMLString(this._theHeader);
    }
    this.InsertRow = function (uid, rowData, flags) {
        var newData = {}
        newData.uid = uid;
        newData.cols = rowData
        newData.flags = flags;
        this._rowData.push(newData);
    }
    this.ResetData = function () {
        this._rowData=[];
    }
    this._filterColumn = 1;
    this.FilterGrid = function (cntrl,column) {
        this._filter = cntrl;
        this._filterColumn=column
        this.Redraw();
    }
    this.Redraw = function () {
        var theTable = ''
        // force column sizes
        theTable += '<table width="100%" class="obj row20px" cellspacing=0 cellpadding=0 border=0 margin=0>'

        theTable += '<tr style="height: auto;">'
        // how big are the fixed columns
        for (var i = 0; i < this._headerData.length; i++) {
            if (this._headerData[i][0] != -1)
                theTable += '<th style="height: 0px; min-width:' + this._headerData[i][0] + 'px;"></th>'
            else
                theTable += '<th style="height: 0px; min-width: ' + this._varWidth + 'px;"></th>'

        }
        theTable += '<th style="height: 0px; width: 20px;"></th></tr>'
        // write the data
        var today = new Date;
        var yr = today.getFullYear();
        var mn = today.getMonth();
        var dy = today.getDate();
        var bgcolor = 'ev_dhx_skyblue'
        var rowselected = ""
        var cellselected = ""
        for (var i = 0; i < this._rowData.length; i++) {
            var item = this._rowData[i]
            var value = item.cols;

            content = value[this._filterColumn];
            content = content.toLowerCase()

            rowselected = ""
            cellselected = ""

            if (this._selectedRows[0] == item.uid) {
                rowselected = "gridrowselected"
                cellselected = "cellselected"
            }

            if (item.flags.indexOf("seen") == -1)
                rowselected += " unseen"

            if (item.flags.indexOf("deleted") != -1)
                rowselected += " deleted"

            if (this._filter == "" || content.indexOf(this._filter) != -1) {
                theTable += '<tr class="' + bgcolor + ' ' + rowselected + '" style="line-height:150%;" onclick="' + this._self + '.RowSelect(' + item.uid + ')" id="' + this._gridId + '_r' + item.uid + '">'
                for (var j = 0; j < this._headerData.length; j++) {
                    var width = this._varWidth;
                    if (this._headerData[j][0] != -1)
                        width = this._headerData[j][0]
                    width -= 8;
                    var val = value[j]
                    if (this._headerData[j][2]=="str"){
                        theTable += '<td class="' + bgcolor + ' ' + cellselected + ' data" align="left" valign="top" style="padding-left:3px;min-width:' + width + 'px;max-width:' + width + 'px;">'
                        theTable += val
                    }
                    else if (this._headerData[j][2] == "date") {
                        theTable += '<td class="' + bgcolor + ' ' + cellselected + ' data" align="right" valign="top" style="min-width:' + width + 'px;max-width:' + width + 'px;">'
                        // two types of display
                        // if the message is for today, show only the time
                        if (val.getFullYear() == yr && val.getMonth() == mn && val.getDate() == dy)
                            theTable += val.toLocaleTimeString();
                        else
                            theTable += val.toLocaleDateString();
                    }
                    else
                    {
                        theTable += '<td class="' + bgcolor + ' ' + cellselected + ' data" align="right" valign="top" style="padding-left:3px;min-width:' + width + 'px;max-width:' + width + 'px;">'
                        theTable += val
                    }
                    theTable += '</td>'
                }
                theTable += '<td></td></tr>'

                if (bgcolor == 'ev_dhx_skyblue')
                    bgcolor = 'odd_dhx_skyblue'
                else
                    bgcolor = 'ev_dhx_skyblue'
            }
        }
        theTable += '</table></div>'
        theTable += '</div>'
        document.getElementById(this._gridId + "_Content").innerHTML = theTable;
    }
    this.SortColumn = function (columnId) {
        if (this._rowData.length == 0)
            return;
        if (typeof this._rowData[0].cols[columnId] === "string")
            this._rowData.sort(function (a, b) { return a.cols[columnId].toLowerCase() > b.cols[columnId].toLowerCase() });
        else
            this._rowData.sort(function (a, b) { return a.cols[columnId] < b.cols[columnId] });
        this.Redraw();
    }
    this.SetRowSelect=function(fn)
    {
        this._onRowSelect = fn;
    }
    this._selectedRows = []

    this.RowSelect = function (uid) {
        // unselect existing rows
        for (var j = 0; j < this._selectedRows.length; j++) {
            var row = document.getElementById(this._gridId + '_r' + this._selectedRows[j])
            row.className = row.className.replace(" gridrowselected", "");
            for (var i = 0; i < row.childNodes.length; i++)
                row.childNodes[i].className = row.childNodes[i].className.replace(" cellselected", "")
        }
        this._selectedRows = [];
        this._selectedRows.push(uid);

        var row = document.getElementById(this._gridId + '_r' + uid)
        row.className += " gridrowselected";
        for (var i = 0; i < row.childNodes.length; i++)
            row.childNodes[i].className += " cellselected"
        if (typeof this._onRowSelect === "function")
            this._onRowSelect(uid);
    }
}